package org.netkernel.xml.accessor;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.util.NKFEntityResolver;
import org.w3c.dom.Document;

public class XIncludeAccessor extends StandardAccessorImpl
{
	private DocumentBuilderFactory mFactory;
	
	public XIncludeAccessor()
	{	this.declareThreadSafe();
		mFactory=DocumentBuilderFactory.newInstance();
		mFactory.setXIncludeAware(true);
		mFactory.setNamespaceAware(true);
		mFactory.setValidating(false);
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	//Object requestedType=context.getThisRequest().getRepresentationClass();
		IReadableBinaryStreamRepresentation opd=context.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		String operandURI=context.getThisRequest().getArgumentValue("operand");
		context.setCWU(operandURI);
		DocumentBuilder db=mFactory.newDocumentBuilder();
		db.setEntityResolver(new NKFEntityResolver(context));
		Document d=db.parse(opd.getInputStream());
		d.setDocumentURI(operandURI);
		context.createResponseFrom(d);
	}
}
