package org.netkernel.xml.accessor;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.util.XMLUtils;
import org.netkernel.xml.xda.DOMXDA;
import org.w3c.dom.Document;

public class XMLMergerAccessor extends StandardAccessorImpl
{
	public XMLMergerAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	
		Iterable<Document> reps=context.source("arg:operand", Iterable.class);
		DOMXDA xda=new DOMXDA(XMLUtils.newDocument(),false);
		String xpath=context.source("arg:xpath", String.class);
		xda.appendPath("/", xpath, null);
		for(Document rep: reps)
		{	xda.append(new DOMXDA(rep, true), "/", xpath);
		}
		INKFResponse resp=context.createResponseFrom(xda.getDocument());
		resp.setMimeType("text/xml");
	}
}
