package org.netkernel.xml.accessor;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.xml.xda.DOMXDA;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class XMLSplitterAccessor extends StandardAccessorImpl
{
	public XMLSplitterAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	Document doc=context.source("arg:operand", Document.class);
		String xpath=context.source("arg:xpath", String.class);
		DOMXDA xda=new DOMXDA(doc, true);
		List<Node> nodelist=xda.getNodesFor(xpath);
		ArrayList<Document> domlist=new ArrayList();
		for(Node n: nodelist)
		{		domlist.add(xda.getFragment(n));
		}
		context.createResponseFrom(Collections.unmodifiableList(domlist));
	}
}
