package org.netkernel.xml.transrepresentation;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.xml.representation.IRepStAX;
import org.netkernel.xml.representation.RepStAX;

/**
 * StAXParser transreptor - attempts to produce a IStAXRepresentation from any resource.
 * @author  tab
 */
public class StAXParser extends StandardTransreptorImpl
{
	public StAXParser()
	{	this.declareThreadSafe();
		this.declareToRepresentation(IRepStAX.class);
		this.declareName("StAXParser");
		this.declareDescription("parses to StAX");
	}
	
	public void onTransrept(INKFRequestContext aContext) throws Exception
	{	IReadableBinaryStreamRepresentation rbs = (IReadableBinaryStreamRepresentation)aContext.sourcePrimary(IReadableBinaryStreamRepresentation.class);
		aContext.createResponseFrom( new RepStAX(rbs) );
	}	
}